/******************************************************************
*                                                                 *
* NNTP client/2                                                   *
*                                                                 *
******************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <os2.h>
#include <os2emx.h>
#include <sys\types.h>
#include <netinet\in.h>
#include <arpa\inet.h>
#include <netdb.h>
#include <sys\socket.h>
#include <unistd.h>
#include <fcntl.h>
#include <io.h>
#include <share.h>
#include <signal.h>
#include <stdarg.h>
#include <sys/stat.h>
#include <sys/errno.h>
#include "sostream\sostream.h"
#include <sys/video.h>
//#include <sys/time.h>
#include <time.h>
#include "FFile\type.h"
#include "FFile\dirs.h"

#define MAXBUF 4097

typedef struct _ART {
    struct _ART *next;
    char *line;
} ART;

int Socket=0, Messages;
void *StreamBuf;
FILE *Received;
time_t Connect_time;
int CurArt, AllArts;
char LastM_ID[MAXBUF];
time_t E_Time_M, E_Time_Art, E_Time;
unsigned int ETM, ETA, AllSize;
char ServerTime[1025];
FILE *TimeStamp;
char Host[254], HostTimeFile[254], NewNews[MAXBUF];

int MYCOMMANDCOLOR=F_RED|B_BLACK;
int RESPONSECOLOR=F_GREEN|B_BLACK;
int MESSAGECOLOR=F_WHITE|B_BLACK;

/*----------------------------------------------------------------------------
	atot() Converts string "YYMMDD HHMMSS" in time
----------------------------------------------------------------------------*/
time_t    atot(char *Date){
struct tm TmpTime;
char *TmpLine;

TmpLine=strdup(Date);
TmpTime.tm_sec=atoi(TmpLine+11); TmpLine[11]=0;
TmpTime.tm_min=atoi(TmpLine+9);  TmpLine[9]=0;
TmpTime.tm_hour=atoi(TmpLine+7); TmpLine[6]=0;
TmpTime.tm_mday=atoi(TmpLine+4); TmpLine[4]=0;
TmpTime.tm_mon=atoi(TmpLine+2);  TmpLine[2]=0;
TmpTime.tm_year=atoi(TmpLine);
free(TmpLine);
return mktime(&TmpTime);
}

/*----------------------------------------------------------------------------
	ttoa() Converts time to string "YYMMDD HHMMSS"
----------------------------------------------------------------------------*/
char *ttoa(time_t Time, char *Str){
struct tm *T;

T = gmtime(&Time);
sprintf(Str, "%02d%02d%02d %02d%02d%02d", T->tm_year, T->tm_mon, T->tm_mday
					, T->tm_hour, T->tm_min, T->tm_sec);
return Str;
}

/*----------------------------------------------------------------------------
    printd() prints out in debug window
----------------------------------------------------------------------------*/
void printd(int Color, const char *format, ...){

static char CurLine=-1;
const char MaxLines=5;
const char D_ColL=0, D_Row=17, D_ColR=79;

va_list ap;
char Mybuf[MAXBUF];

va_start(ap, format);
vsprintf(Mybuf, format, ap);
va_end(ap);

Mybuf[79]=0;

v_attrib(Color);
if(CurLine == MaxLines) {
	v_scroll(D_ColL, D_Row, D_ColR, D_Row+MaxLines, 1, V_SCROLL_UP);
	}
else
	 CurLine++;
v_gotoxy(D_ColL,D_Row+CurLine);
v_puts(Mybuf);

return;
}

/*----------------------------------------------------------------------------
    ExitProgram() closes needed files and terminates program correctly
----------------------------------------------------------------------------*/
void ExitProgram(int signo){
	if(Ffile("delete.msg",FA_All)==0){
		close(Messages);
		unlink("messages.ids");
		unlink("delete.msg");
		}
	if(Socket){
		SoStreamPuts(Socket, "quit");
		printd(MYCOMMANDCOLOR,"QUIT\n");
		SoStreamClose(Socket);
	}
	printd(MESSAGECOLOR,"Program aborted by user break\n");
	exit(0);
}

/*----------------------------------------------------------------------------
    save_art() saves article art and saves into file Rnews, release art.
----------------------------------------------------------------------------*/
int save_art(ART *art, int Rnews, int Size){
ART *MyArt;
char MyBuf[80];

sprintf(MyBuf,"#! rnews %ld\x0A", Size);
write(Rnews, MyBuf, strlen(MyBuf));
while(art){
	write(Rnews, art->line, strlen(art->line));
	write(Rnews, "\x0A",1);
//	printf(">>> %s\n",art->line);
	free(art->line);
	MyArt=art;
	art=art->next;
	free(MyArt);
	}
}

/*----------------------------------------------------------------------------
	get_art() receives article Mess_ID and saves into ART *art
----------------------------------------------------------------------------*/
int get_art(char *Mess_ID, ART **artA){
int rc, FL, ArtSize;
char MyBuf[MAXBUF];
ART *MyArt, *art;

art=*artA;
strcpy(MyBuf,"article ");
strcat(MyBuf, Mess_ID);
rc = SoStreamPuts(Socket,MyBuf);
printd(MYCOMMANDCOLOR,"article %s\n",Mess_ID);

FL=1; ArtSize=0;
while(1){
	v_attrib(F_WHITE|B_BLUE|INTENSITY);
	v_gotoxy(1,8);
	v_printf("Art Size  : %7ld",ArtSize);
	rc = SoStreamBufGets(MyBuf,MAXBUF-1,StreamBuf);
	if(rc==-1) return 0;
	if(FL){
		printd(RESPONSECOLOR,"%s\n",MyBuf);
		if(strstr(MyBuf,"220 ")==MyBuf){
			FL=0;
			continue;
			}
		if(strstr(MyBuf,"430 ")==MyBuf) return -1;
		return -1;
		}
	if(strcmp(MyBuf,".")==0){
		break;
		}

	if(art==0){
		art = malloc(sizeof(ART));
		*artA=art;
		}
	else{
		art->next = malloc(sizeof(ART));
		art = art->next;
		}
	art->next=0;
	art->line=strdup(MyBuf);
	ArtSize+=strlen(MyBuf)+1;
	AllSize+=strlen(MyBuf)+1;
	if(strstr(MyBuf,"Newsgroups: ")==MyBuf){
		MyBuf[57]=0;
		v_gotoxy(22,8);
		v_attrib(F_WHITE|B_BLUE|INTENSITY);
		v_printf("%-57s",MyBuf);
		}
	time(&E_Time);
	ETM=difftime(E_Time,E_Time_M);	ETA=difftime(E_Time,E_Time_Art);
	v_gotoxy(1,9);
	v_attrib(F_WHITE|B_BLUE|INTENSITY);
	v_printf("Art Speed     : %6ld cps", (ETA > 0) ? ArtSize/ETA : 0);
	v_gotoxy(1,10);
	v_printf("Average Speed : %6ld cps", (ETM > 0) ? AllSize/ETM : 0);
	}
return ArtSize;
}

/*----------------------------------------------------------------------------
	get_last_rnews() returns max number of rnews + 1
----------------------------------------------------------------------------*/
int get_last_rnews(){
int LastRnews,Value;
char FN[256];

LastRnews=1;
if(Ffile("rnews???",FA_All)) return 1;

Fname(FN);
Value=atoi(FN+strlen(FN)-3);
LastRnews = (Value > LastRnews) ? Value : LastRnews;
printd(MESSAGECOLOR,"Skipped %s : Value = %d\n",FN, Value);

while(Ffile(0,FA_All)==0){
	Fname(FN);
	Value=atoi(FN+strlen(FN)-3);
	printd(MESSAGECOLOR,"Skipped %s : Value = %d\n",FN, Value);
	LastRnews = (Value > LastRnews) ? Value : LastRnews;
	}
return LastRnews+1;
}

/*----------------------------------------------------------------------------
	stripcrlf() deletes \r\n in end of string and spaces
----------------------------------------------------------------------------*/
void stripcrlf(char *temp) {
char *point;
int Cc;
if(temp) {
	if(point=strchr(temp,'\r')) {
		*point='\0';
		}
	if (point=strchr(temp,'\n')) {
		*point='\0';
		}
	}
	for(Cc=strlen(temp);Cc;Cc--){
		if(temp[Cc]==' '){temp[Cc]=0;continue;}
		break;
		}
}

/*----------------------------------------------------------------------------
	getmsgs() receives list of messages-id into file "messages.ids"
----------------------------------------------------------------------------*/
int getmsgs(){
int rc, FLine, DelMsg;
char buffer[1025], tmpline[1025];
char NewTime[7], NewDate[7];
time_t TTT;

rc = SoStreamPuts(Socket,"date");
printd(MYCOMMANDCOLOR,"DATE\n");
if(rc==-1){
	printd(MESSAGECOLOR,"Error in socketconnection\n");
	return 3;
	}

rc = SoStreamBufGets(buffer, MAXBUF-1, StreamBuf);
if(rc==-1){
	printd(MESSAGECOLOR,"Error in socketconnection\n");
	return 4;
	}

printd(RESPONSECOLOR,"%s\n",buffer);

if(strstr(buffer,"111 ")!=buffer){
	printd(RESPONSECOLOR,"%s\n",buffer);
	printd(MESSAGECOLOR,"Not conditioned answer\n");
	return 5;
	}
strcpy(NewTime, strchr(buffer,' ')+9);
*(strchr(buffer,' ')+9)=0;
strcpy(NewDate, strchr(buffer,' ')+3);

strcpy(HostTimeFile,Host);
strcat(HostTimeFile,".tim");
if(Ffile(HostTimeFile,FA_All) || !Fsize()){
	printd(MESSAGECOLOR,"%s.TIM not found or has a zero length. Looking for %s.BAK\n", Host, Host);
	strcpy(HostTimeFile,Host);
	strcat(HostTimeFile,".bak");
	if(Ffile(HostTimeFile,FA_All) || !Fsize()){
		printd(MESSAGECOLOR,"%s.BAK not found or has a zero length.\n", Host);
		printd(MESSAGECOLOR,"Operation is not permitted. Exiting\n");
		return 6;
		}
	}
TimeStamp = fopen(HostTimeFile,"r");
if(TimeStamp==0){
	printd(MESSAGECOLOR,"Can not open file \"%s\"",HostTimeFile);
	return 2;
	}
fgets(tmpline,1024,TimeStamp);
stripcrlf(tmpline);
fclose(TimeStamp);
TTT=atot(tmpline)-3*3600-1;
strcpy(buffer,"NEWNEWS ");
strcat(buffer,NewNews);
strcat(buffer," ");
strcat(buffer,ttoa(TTT, ServerTime));
v_gotoxy(54,2);
v_attrib(F_WHITE|B_BLUE|INTENSITY);
v_printf("News from: %s",ServerTime);
printd(MYCOMMANDCOLOR,"%s\n",buffer);
rc = SoStreamPuts(Socket,buffer);
if(rc==-1){
	printd(MESSAGECOLOR,"Error in socketconnection\n");
	return 3;
	}

FLine=1; AllArts=0;
while(1){
	rc = SoStreamBufGets(buffer, MAXBUF-1, StreamBuf);
	if(rc==-1){
		printd(MESSAGECOLOR,"Error in socketconnection\n");
		ExitProgram(0);
		}
/*	stripcrlf(buffer);	*/
	if(FLine==1){
		if(strstr(buffer,"230 ")==buffer){
			printd(RESPONSECOLOR,"%s\n",buffer);
			FLine=0;
			continue;
			}
		else{
			printd(RESPONSECOLOR,"%s\n",buffer);
			return 5;
			}
		}
	if(strcmp(buffer,".")==0){
		if(FLine==0){	/*	 뫮  ⥩	*/
			break;
			}
		close(Messages);
		unlink("delete.msg");
		break;
		}
	if(FLine==0){
		Messages = sopen("messages.ids", O_WRONLY|O_BINARY|O_CREAT|O_TRUNC , SH_DENYRW,S_IREAD | S_IWRITE);
		if(Messages==-1){
			printd(MESSAGECOLOR,"Can not open file \"MESSAGES.IDS\"\n");
			ExitProgram(0);
			}
		DelMsg = sopen("delete.msg", O_WRONLY|O_BINARY|O_CREAT|O_TRUNC , SH_DENYRW,S_IREAD | S_IWRITE);
		if(Messages==-1){
			printd(MESSAGECOLOR,"Can not create semafor file DELETE.MSG\n");
			ExitProgram(0);
			}
		close(DelMsg);
		FLine=2;
		}
	write(Messages, buffer, strlen(buffer));
	write(Messages, "\x0D\x0A", 2);
	printd(RESPONSECOLOR,"%s\n",buffer);
	++AllArts;
	v_gotoxy(1,6);
	v_printf("Max Art    : %6ld",AllArts);
	}

if(strstr(strrchr(HostTimeFile,'.'),".tim")){	/* .tim normally */
	strcpy(HostTimeFile,Host);
	strcat(HostTimeFile,".bak");
	unlink(HostTimeFile);
	strcpy(buffer,Host);
	strcat(buffer,".tim");
	rename(buffer,HostTimeFile);
	}
strcpy(HostTimeFile,Host);
strcat(HostTimeFile,".tim");
TimeStamp = fopen(HostTimeFile,"w");
	if(TimeStamp==0){
		printd(MESSAGECOLOR,"Can not open file \"%s\"\n",HostTimeFile);
		return 6;
		}
fprintf(TimeStamp,"%s %s\n",NewDate,NewTime);
fclose(TimeStamp);
if(FLine==0)
	return 1;
return 0;
}

/*----------------------------------------------------------------------------	
	SLURP - passive NNTP client supporting REGET a broken news.
----------------------------------------------------------------------------*/
int main(void){

char buffer[MAXBUF], RnewsName[15];
int rc, RecSize, MesSize, RnewsCount, Rnews, RnewsOPEN, ArtSize, RnewsSize;
ART *article;
int LastM_ID_Pos, TmpID, RecArts;
FILE *Messages;

v_init();
v_clear();
v_gotoxy(0,0);
v_attrib(F_WHITE|B_CYAN|INTENSITY);
v_puts("    Passive NNTP client for OS/2 v0.2alpha. Copyright (C) 1996 Andy Hohutkun    ");
v_gotoxy(0,16);
v_attrib(F_BLACK|B_GREEN);
v_puts("    DEBUG WINDOW                                                                ");
v_gotoxy(0,16+7);
v_puts("                                                                                ");
v_gotoxy(0,1);
v_attrib(F_WHITE|B_BLUE);
v_puts("Ŀ");
//for(rc=0;rc<13;rc++)
v_puts("                                                                              ");
v_puts("                                                                              ");
v_puts("                                                                              ");
v_puts(" Basic Statistics Ĵ");
v_puts("                                                                              ");
v_puts("                                                                              ");
v_puts("                                                                              ");
v_puts("                                                                              ");
v_puts("                                                                              ");
v_puts("");
SoStreamInit();
signal(SIGINT,ExitProgram);
strcpy(Host,"icomm");
strcpy(NewNews,"*,!relis.*,!demos.*,!comp.*,comp.os.os2*");

if(Ffile("delete.msg",FA_All)==0){
	printd(MESSAGECOLOR,"Found bad attempt to receive message-IDs list. Delete them.\n");
	if(Ffile("messages.ids",FA_All)==0)
		unlink("messages.ids");
	unlink("delete.msg");
	}

printd(MESSAGECOLOR,"Try to connect to %s by port 119\n",Host);
Socket = SoStreamConnect(Host,"nntp",119);
if(Socket <= 0){
	printd(MESSAGECOLOR,"Can not connect to %s\n", Host);
	return 1;
	}
time(&Connect_time);
printd(MESSAGECOLOR,"Connected to %s by port 119\n", Host);
v_gotoxy(1,2);
v_attrib(F_WHITE|B_BLUE|INTENSITY);
v_printf("Connected to %s at %s", Host,ctime(&Connect_time));
v_gotoxy(1,3);
v_printf("NEWNEWS %s", NewNews);

StreamBuf = SoStreamBufCreate(Socket);

//_beginthread(Control_Sockets);

rc = SoStreamBufGets(buffer, MAXBUF-1, StreamBuf);
if(rc==-1){
	printd(MESSAGECOLOR,"Error in socketconnection 2\n");
	SoStreamBufDestroy(StreamBuf);
	SoStreamClose(Socket);
	return 2;
	}

printd(RESPONSECOLOR,"%s\n",buffer);

if(strstr(buffer,"200 ")!=buffer){
	printd(MESSAGECOLOR,"First message is not 200!\n");
	SoStreamBufDestroy(StreamBuf);
	SoStreamClose(Socket);
	return 3;
	}


if(Ffile("messages.ids",FA_All) || !Fsize()){
	printd(MESSAGECOLOR,"Messages.ids not found. Let's get messages.ids list\n");
	rc = getmsgs();
	if(rc>1){
		printd(MESSAGECOLOR,"Error while to get list of message ids\n");
		SoStreamBufDestroy(StreamBuf);
		SoStreamClose(Socket);
		return 4;
		}
	if(rc == 1){
		printd(MESSAGECOLOR,"No news at once\n");
		rc = SoStreamPuts(Socket, "quit");
		printd(MYCOMMANDCOLOR,"QUIT\n");
		SoStreamClose(Socket);
		return 1;
		}
	}

Received = fopen("received.ids","a+b");
if(Received==0){
	printd(MESSAGECOLOR,"Can not open file \"RECEIVED.IDS\"\n");
	return 6;
	}
Messages = fopen("messages.ids","rb");
if(Messages==0){
	printd(MESSAGECOLOR,"Can not open file \"MESSAGES.IDS\"\n");
	return 6;
	}
RecSize=ftell(Received);
/*---------------------------------
  Count already received articles
---------------------------------*/
CurArt=0;
fseek(Received,0,SEEK_SET);
TmpID=0;
v_attrib(F_WHITE|B_BLACK|INTENSITY);
while(1){
	LastM_ID_Pos=TmpID;
	TmpID=ftell(Received);
	if(fgets(buffer,MAXBUF-1,Received)==0) break;
	++CurArt;
	stripcrlf(buffer);
	strcpy(LastM_ID,buffer);
	v_gotoxy(1,7);
	buffer[45]=0;
	v_printf("Current Art: %6ld  Message-ID: %-45s",CurArt,buffer);
	}

/*---------------------------------
       Count all articles
---------------------------------*/
AllArts=0;
fseek(Messages,0,SEEK_SET);
v_attrib(F_WHITE|B_BLUE|INTENSITY);
while(fgets(buffer,MAXBUF-1,Messages)){
	++AllArts;
	v_gotoxy(1,6);
	v_printf("Max Art    : %6ld",AllArts);
	}

if(AllArts<CurArt){
	printd(MESSAGECOLOR,"Current article larger than Max\n");
	ExitProgram(0);
	}

if(RecSize){
	fseek(Messages,LastM_ID_Pos,SEEK_SET);
	fgets(buffer,MAXBUF-1,Messages);
	stripcrlf(buffer);
	if(strcmp(buffer,LastM_ID)){
		printd(MESSAGECOLOR,"Last received message-ID not found in file \"MESSAGES.IDS\"\n");
		printd(MESSAGECOLOR,"%s\n",LastM_ID);
		printd(MESSAGECOLOR,"%s\n",buffer);
		ExitProgram(0);
		}
	MesSize=ftell(Messages);
	if(MesSize!=RecSize){
		printd(MESSAGECOLOR,"File positions are not equivalent for REGET\n");
		ExitProgram(0);
		}
	printd(MESSAGECOLOR,"Continuing at position %d\n", RecSize);
	}
else{
	fseek(Messages,0,SEEK_SET);
	}

RnewsCount=get_last_rnews();

RnewsOPEN=0; RecArts=0; RnewsSize=0, AllSize;
time(&E_Time_M);
while(fgets(buffer,MAXBUF-1,Messages)){
	v_gotoxy(60,6);
	v_attrib(F_WHITE|B_BLUE|INTENSITY);
	v_printf("Rnews Size: %7ld",RnewsSize);
	if(RnewsOPEN==0){
		sprintf(RnewsName, "rnews%03d",RnewsCount);
		printd(MESSAGECOLOR,"Rnewsfile - %s\n",RnewsName);
		v_attrib(F_WHITE|B_BLUE|INTENSITY);
		v_gotoxy(22,6);
		v_printf("Current batch file: %s",RnewsName);
		Rnews = sopen(RnewsName, O_WRONLY|O_BINARY|O_CREAT|O_TRUNC , SH_DENYWR,S_IREAD | S_IWRITE);
		if(Rnews==0){
			printd(MESSAGECOLOR,"Can not create file %s\n",RnewsName);
			return 6;
			}
		RnewsOPEN=1;
		RnewsSize=0;
		}
	stripcrlf(buffer);
	strcpy(LastM_ID,buffer);
	v_gotoxy(1,7);
	LastM_ID[45]=0;
	++RecArts;
	v_attrib(F_WHITE|B_BLUE|INTENSITY);
	v_printf("Current Art: %6ld  Message-ID: %-45s",CurArt+RecArts,LastM_ID);
	article = 0;
	time(&E_Time_Art);
	ArtSize = get_art(buffer, &article);
	if(ArtSize==0){
		printd(MESSAGECOLOR,"Can not get article %s\n",buffer);
		printd(MESSAGECOLOR,"Saving a state... ");
		close(Rnews);
		fclose(Received);
		fclose(Messages);
		printd(MESSAGECOLOR,"Ok\n");
		return 10;
		}
	if(ArtSize > 0) {
		save_art(article, Rnews, ArtSize);
		RnewsSize+=ArtSize;
		}
	else{
		printd(MESSAGECOLOR,"Article skipped...\n");
		}
	fprintf(Received,"%s\r\n",buffer);
	if(RnewsSize > 300000){
		close(Rnews); RnewsOPEN=0; RnewsCount++;
		fclose(Received);
		Received = fopen("received.ids","a+b");
		if(Received==0){
			printd(MESSAGECOLOR,"Can not open file \"RECEIVED.IDS\"\n");
			return 6;
			}
		}
	}	/*	end of while(fgets())	*/
if(RnewsOPEN){
	close(Rnews);
	}
fclose(Messages);
fclose(Received);
unlink("messages.ids");
unlink("received.ids");

rc = SoStreamPuts(Socket, "quit");
printd(MYCOMMANDCOLOR,"QUIT\n");
SoStreamClose(Socket);
return 0;
}
