/*
 * This part was hacked by Harald Kipp
 *
 * Bug reports should be sent to
 *
 *  harald@os2point.ping.de
 *  harald@haport.sesam.com
 *  Fido: 2:2448/434
 *
 */

#include <sys\types.h>
#include <sys\socket.h>

#include <stdio.h>

#include "chlimits.h"
#include "sostream.h"

#include "sos_glob.h"

typedef struct {
    int  sock;
    int  ibuf;
    int  pbuf;
    char buffer[MAX_BUFSIZ];
} STRECBUF;

/************************************************************************/
/*  Buffered i/o used with multi threaded applications.                 */
/*                                                                      */
/************************************************************************/
void *  SoStreamBufCreate(int sock)
{
    STRECBUF *rb = malloc(sizeof(STRECBUF));

    rb->sock = sock;
    rb->ibuf = 0;
    rb->pbuf = 0;

    return(rb);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
void SoStreamBufDestroy(void *rbv)
{
    STRECBUF *rb = rbv;

    if(rb)
        free(rb);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
static int recb_char(STRECBUF *rb, char *ch)
{
    if(rb->ibuf == rb->pbuf) {
        rb->pbuf = 0;
        if((rb->ibuf = recv(rb->sock, rb->buffer, sizeof(rb->buffer), 0)) <= 0)
            return(rb->ibuf);
    }
    *ch = rb->buffer[rb->pbuf++];
    return(1);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
int SoStreamBufGets(char *pline, size_t n, void *rbv)
{
    STRECBUF *rb = rbv;
    register int rc;
    register char *cp = pline;
    char cl = '\0';
    int cc = 0;

    while ((rc = recb_char(rb, cp)) > 0) {
        if (*cp == '\n') {
            if(cl == '\r')
                cp--;
            else
                cc++;
            *cp = '\0';
            break;
        }
        cl = *cp++;
        if(++cc >= n) {
            *cp = '\0';
            break;
        }
    }
/*    return((rc > 0) ? cc : rc);	Andy*/
    return((rc > 0) ? cc : -1);
}
